
public class Friend implements Runnable {
	
	// permissions to open a door
	private boolean hasPermission = true;
	
	// name of friend for reference
	public final String name;
	
	// number of zombies let in by this friend
	private volatile int zombiesLetIn = 0;

	// constructor
	public Friend(String n){
		name = n;
	}
	
	// sets permission 
	public void setPermission(boolean x){
		hasPermission = x;
		if (x==false){
			// Thread.yield();	// decided not to do this in the
								// end because it would happen too often and it doesn't
								// seem to make a noticeable difference in throughput anyway
		} else {
			//System.out.println(name+"'s door is open.");
		}
	}
	
	// allows someone else to know how many zombies this friend has let through his/her door in total
	public int getCount(){
		return this.zombiesLetIn;
	}
	
	private synchronized void letInZombie(){
		zombiesLetIn++;
	}
	

	public void run(){
		
		// continuously repeat the following until the shooter says to stop:
		while (Shooter.isRunning){
			// if this friend has permission to let a zombie in, do so with a 10% chance
			if(Math.floor(10*Math.random()) == 0 && hasPermission){
				letInZombie(); // increment number of zombies that this friend has let in.	Note: synchronized
				//System.out.println(name + " let in a zombie. count: "+count);
				
			} else if (!hasPermission) {
				//System.out.println(name + "'s door is closed. count: "+count);
			}
			try { Thread.sleep(10); } catch (InterruptedException e) {}	 // sleep for 10ms
		}
	}
}