import java.util.Random;

// continuously manipulates a circular singly linked list by either adding or removing random nodes or advancing to the next node.
public class Editer implements Runnable {
	
	// creates an object for a circular singly linked list
	public static LetterCSLL theList = new LetterCSLL();
	
	// flag to help stop threads
	private static boolean isRunning = true;
	
	// returns true if this thread is running
	public static boolean isRunning(){
		return isRunning;
	}
	
	// used to kill this thread
	public static void setRunning(boolean x){
		isRunning = x;
	}
	
	// code for Editer thread (this thread)
	public void run(){
		
		// random object used for generating a random letter
		Random generator = new Random();
		
		// stores the current random number to decide which operation to perform
		double currentRandomNumber;
		
		// create a node for current node
		LetterNode currentNode = new LetterNode(   (char)(65 + generator.nextInt(25))   );
		
		// temporary nodes for random remove
		LetterNode temp;
		LetterNode nodeRemoved;
		
		// create printer thread
		Thread printer = new Thread(new Printer());
		
		// add a node before printer starts
		theList.add( currentNode );
		
		// set current node
		currentNode = theList.getListHead();
		
		// start printer thread
		printer.start();
		
		// continuously repeat the following:
		while(isRunning){
			
			// set current random number
			currentRandomNumber = Math.random();
			
			// perform one of the following three operations:
			if (currentRandomNumber < (1/(double)3)){
				// 1. add a random node at current location

				theList.add(currentNode, new LetterNode(   (char)(65 + generator.nextInt(25))   ));
		//		System.out.println( " \'"+temp.getLetter()+"\'" + " was added.");

			} 
			else if (currentRandomNumber >= (1/(double)3) && currentRandomNumber < (2/(double)3)){
				// 2. remove a node

				if (currentNode == null){
					System.out.println("cannot remove null");
				} else if (currentNode.equals(theList.getListTail())) {
					// do nothing (never remove the tail)
					
				} else {
					
					temp = new LetterNode(currentNode.getLetter());
					if (currentNode.getNext() != null) {
						temp.setNext(currentNode.getNext());
					} else {
						temp.setNext(temp);
					}
					
					// remove the node
					nodeRemoved = theList.remove(currentNode);	// save it just in case you want the following printout
					if (nodeRemoved == null){
						//do nothing
					} else {
		//				System.out.println(" \'"+nodeRemoved.getLetter()+"\'" + " was removed.");
					}
					
					// if the removed node had a next node that's not itself (should always be the case)
					if (temp.getNext() != null && !temp.getNext().equals(temp)){
						currentNode = temp.getNext();	// sets current node to the one after the removed node.

					} else {	// in case something gets messed up
						currentNode = theList.getListHead();
					}
				}
				temp = null;
				nodeRemoved = null;

				
			} else { /**  if currentRandomNumber >= (2/(double)3)  **/ 
				// 3. go to next node (if current node and next node exist)
				if (currentNode !=null && currentNode.getNext() != null ){

					// perform the operation (go to next node)
					currentNode = currentNode.getNext();
	//			System.out.println(" editer pointer advanced.");
				}
			}

			// sleep for 100ms
			try {Thread.sleep(100);} catch (InterruptedException e) {}
		
		}

	}
}

