// represents a circular singly linked list of letterNodes.

public class LetterCSLL {
	
	// pointer to head of circular singly linked list
	private LetterNode head = null;
	
	// pointer to tail of circular singly linked list
	private LetterNode tail = null;
	
	// flag signifying empty list
	private boolean isEmpty = false;
	
	// returns true if list is empty, false otherwise
	public boolean isEmpty(){
		return isEmpty;
	}
	
	// returns the head of the list
	public LetterNode getListHead(){
		return head;
	}
	
	// returns the tail of the list
	public LetterNode getListTail(){
		return tail;
	}
	
	// adds a LetterNode to end of the list
	public void add(LetterNode newNode){
		
		
		// if the head of the list is null, the list is empty
		// so make the new node the head of the list
		// and set its next node to be itself (circular)
		if (head == null){
			head = newNode;
			tail = newNode;
			newNode.setNext(newNode);
			isEmpty = false;
			
			
		// if the list is not empty
		} else {

			// set the tail's next to the new node
			tail.setNext(newNode);
			
			// set the new node to be the new tail
			tail = newNode;
			
			// set the new node's next to be the head
			newNode.setNext(head);
		}
	}
	
	// adds a new node after a particular index
	public void add(LetterNode idx, LetterNode newNode){

		if (idx.equals(tail)){
			
			// adjust pointers to add new node properly
			idx.setNext(newNode);
			newNode.setNext(head);
			newNode = head;
			
		} else {
			// adjust pointers to add new node properly
			newNode.setNext(idx.getNext());
			idx.setNext(newNode);
		}
	}
	
	
	// removes and returns a particular LetterNode
	// returns null if list is empty or if node not found
	public LetterNode remove(LetterNode target){
		
		if (target == null){
			return null;
		}
		
		LetterNode ptr = head;	// pointer to a node in list starting at head
		
		// if list is empty
		if (head == null){	
			System.out.println("Remove was called on an empty list.  node not removed.");
			return  null;
			
		// if list only has one node in it
		} else if (head.equals(tail) && head.equals(target)) {
			// do not remove the node
			// (do nothing)
			System.out.println("Remove was called on a list containing only one node.  node not removed.");
			return null;
		
		// if there's more than one node in the list, try to remove it:
		} else {
			
			// point ptr at the node before the target (note: assumes target is in the list!)
			while (!ptr.getNext().equals(target)){
				ptr = ptr.getNext();
			}
			
			// adjust pointers to remove target
			ptr.setNext(target.getNext());
			//target.setNext(null); // don't do this because it will screw up the printer thread!
		}
		return target;
	}
}
