// represents one node of a linked list where each node
// contains a character and a pointer to the next node.

public class LetterNode {
	
	// pointer to a node's next node
	private volatile LetterNode next = null;
	
	// character stored in a particular node
	private char c;
	
	// constructor for a node
	public LetterNode(char letter){
		c = letter;
	}

	// returns the character stored in this node
	public char getLetter(){
		return c;
	}
	
	// gets this node's next node.  (Note: could be null)
	public LetterNode getNext(){
		if (next == null){
			return null;
		}
		return next;
	}
	
	// sets the 'next' pointer to the passed node
	public void setNext(LetterNode nextNode){
		next = nextNode;
	}

}
